routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
/* YUNG DATI for education purposes
Route::get('/', function () {
    $name = 'Alex';
    return view('names.show-names') //yung folder'names.show-names', period ginagamit instead of slash
    ->with('name',['Alex','Ben','Sylvan']); 

});
*/

Route::get('/', function () {
    return view('welcome');


});

Route::delete('/carts/empty', 'CartController@empty')->name('carts.empty');

Route::post('/transactions/paypal','TransactionController@create_paypal_payment')->name('transactions.paypal');

Route::resource('categories','CategoryController');
Route::resource('products', 'ProductController');
Route::resource('carts', 'CartController');
Route::resource('transactions','TransactionController');


//to view create page

/*
Route::get('/categories/create','CategoryController@create')->name('categories.create');

Route::get('/categories', 'CategoryController@index')->name('categories.index');

Route::get('/categories/{category}','CategoryController@show')->name('categories.show');

Route::get('/categories/{category}/edit','CategoryController@edit')->name('categories.edit');

Route::post('/categories','CategoryController@store')->name('categories.store');

Route::put('/categories/{category}','CategoryController@update')->name('categories.update');

Route::delete('/categories/{category}','CategoryController@destroy')->name('categories.destroy');
*/
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

app/Http/Controllers/CartController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use Session;
use App\Product;

class CartController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
       
       if(Session::has('cart')) {
            //get all ids
        $product_ids = array_keys(Session::get('cart'));
        // query to the database
        // get all products that are in the session cart

        $products = Product::find($product_ids);

        $total = 0;

        foreach($products as $product) {
            $product->quantity = Session::get("cart.$product->id");
            $product->subtotal = $product->quantity * $product->price;
            $total += $product->subtotal;
        };

        // dd($products);
        return view('carts.index')->with('products', $products)->with('total',$total);
       } else {
            return view('carts.index');
       }    
       
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        //
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $cart)
    {
        $request->validate(['quantity'=>'required|min:1']);

        $qty = $request->quantity;
        $request->session()->put("cart.$cart", $qty);

       // dd(Session::get('cart'));
        // dd($request->session()->get('cart'));
        

        return redirect( route('carts.index'));
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy(Request $request, $cart)
    {
        $request->session()->forget("cart.$cart");

        if(count($request->session()->get('cart'))==0) {
            $request->session()->forget("cart");
        }

        return redirect( route('carts.index'))->with('status', 'Product removed from cart.');
    }

    public function empty(){

        Session::forget('cart');
        return redirect(route('carts.index'))->with('status',"Cart is cleared.");
    }
}

resources/views/carts/index.blade.php
@extends('layouts.app')

@section('content')

 {{-- {{ dd(Session::get('cart')) }} --}}
	<div class="container">
		<div class="row">



			<div class="col-12">
				<h3>My Cart</h3>
				@include('products.includes.error-status')
			</div>
			
			@if(Session::has('status'))
					<div class="col-12">
						<div class="alert alert-warning">
							{{ Session::get('status') }}
						</div>
					</div>
			@endif



			@if(Session::has('cart'))
			<div class="col-12">

				{{-- TABLE STARTS HERE --}}
				<div class="table-responsive">
					<table class="table table-striped table-hover text-center">
						<thead>
							<th scope="col">Name</th>
							<th scope="col">Price per Unit</th>
							<th scope="col">Quantity</th>
							<th scope="col">Subtotal</th>
							<th scope="col">Action</th>
						</thead>

						<tbody>
							@foreach($products as $product)
							{{-- START OF ROW --}}
								<tr>
									{{-- name --}}
									<th scope="row">
									{{$product->name}}
								</th>
									{{-- price --}}
									<td>
										&#8369; <span>{{ number_format($product->price,2) }}</span>
									</td>
									{{-- quantity --}}
									<td>
										<div class="add-tocart-field mb-1">
											<form action="{{ route('carts.update',['cart' => $product->id])}}" method="POST">
												@csrf
												@method('PUT')

												<input type="number" name="quantity" id="quantity" class="form-control mb-2 w-100" value="{{$product->quantity}}" min="1">
												<button class="btn btn-outline-secondary w-100" type="submit">Edit</button>
											</form>
										</div>
									</td>
									{{-- subtotal --}}
									<td>
										&#8369; <span>{{number_format($product->subtotal,2)}}</span>
									</td>
									{{-- action --}}
									<td>
										<form action="{{ route('carts.destroy', ['cart'=> $product->id])}}" method="POST">
											@csrf
											@method('DELETE')
											<button class="btn btn-danger w-100">
												Remove from Cart
											</button>
										</form>
									</td>
								</tr>
							{{-- END OF ROW --}}
							
							@endforeach

						</tbody>
						<tfoot>
							<tr>
								<td colspan="3" class="text-right bg-secondary text-light">
								Total
							</td>
							<td class="bg-secondary text-light">
										&#8369; <span id="total">{{number_format($total,2)}}</span>
							</td>
							{{-- action --}}
									<td class="bg-secondary">
										
										@can('isLogged')
										<form action="{{ route('transactions.store') }}" method="POST">
											@csrf
											<button class="btn btn-primary w-100 mb-3">
												Checkout
											</button>
										</form>
										<div id="paypal-btn">
											
										</div>

										@endcan
										@cannot('isLogged')
											<a href="{{ route('login') }}" class="btn btn-success w-100">Please Login to Continue</a>
										@endcannot

									</td>
							</tr>
						</tfoot>
					</table>
					{{-- END OF TABLE --}}
				<form action="{{ route('carts.empty')}}" method="POST">
					@csrf
					@method('DELETE')
				<button type="submit" class="btn btn-outline-danger">
												Clear Cart
											</button>
				</form>							
				</div>
			</div>
			@else
					<div class="col-12">
						<div class="alert alert-info text-center">
							<h1>&#128544; Your Cart is Empty!!! &#128544;</h1>
						</div>
					</div>
			@endif
		</div>
	</div>

<script src="https://www.paypal.com/sdk/js?client-id=AaR7pFBDf38hOkFkwVWOip418KchDWejh2Mj7CobbcgWx8G_xAVKdMGrKDnO1bw8BwAW23uSVOEySnXn"></script>
<script>
	paypal.Buttons({
	createOrder: function(data, actions) {
      // This function sets up the details of the transaction, including the amount and line item details.
      return actions.order.create({
        purchase_units: [{
          amount: {
            value: {{ isset($total) ? $total : "0" }}
          }
        }]
      });
    },

  onApprove: function(data, actions) {
    // This function captures the funds from the transaction.
    return actions.order.capture().then(function(details) {
      // This function shows a transaction success message to your buyer.
      alert('Transaction completed by ' + data.orderID);

      let csrfToken = document.querySelector('meta[name="csrf-token"]').getAttribute('content');

      let transaction = { transactionCode : data.orderID };

      fetch("{{ route('transactions.paypal') }}", {
      		method: 'post',
      		body: JSON.stringify(transaction),
      		headers: {'X-CSRF-TOKEN': csrfToken}
      	})
      .then(response =>response.json())
      .then(res =>{
        	window.location.href = "/transactions/" + res.transaction_id
      });
    })
  }
}).render('#paypal-btn');
</script>
@endsection